<template>
  <div class="col-12">
    <!-- ERROR MESSAGE -->
    <div class="row">
      <div class="col-10 offset-1">
        <div class="alert alert-danger w-100" role="alert" v-if="getError">
          {{ getError }}
        </div>
      </div>
    </div>

    <!-- ADD DISTRIBUTION FORM -->
    <div class="row mb-3">
      <div class="col-1 mt-3 pr-0 text-right">
        <span class="arrow text-primary" v-if="!distributionVisible" @click="toggleDistribution()">
          <i class="material-icons text-dark">keyboard_arrow_down</i>
        </span>
        <span class="arrow text-primary" v-else @click="toggleDistribution()">
          <i class="material-icons text-dark">keyboard_arrow_up</i>
        </span>
      </div>
      <div class="col-10 py-2 text-left">
        <h3 class="heading" @click="toggleDistribution()">{{ $t('message.metadata.distribution') }}</h3>
        <div class="description text-muted" @click="toggleDistribution()">{{ $t('message.metadata.pageDescriptionDistribution') }}</div>
      </div>
      <div class="col-10 offset-1" v-if="distributionVisible">
        <!-- ADD DISTRIBUTION TITLE -->
        <div class="input-group mb-3">
          <label class="w-100" for="title">
            <span class="align-middle">{{ $t('message.metadata.title') }}</span>
            <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipDistributionTitle')">info</i>
          </label>
          <input class="form-control w-100"
                 id="title"
                 name="Title"
                 type="text"
                 :placeholder="$t('message.metadata.enterTitle')"
                 :aria-label="$t('message.metadata.enterTitle')"
                 aria-describedby="title"
                 v-model="distribution.title"
                 v-validate="'required'">
          <br>
          <div class="alert alert-danger w-100" role="alert" v-if="errors.first('Title')">
            {{ errors.first('Title') }}
          </div>
        </div>
        <!-- ADD DISTRIBUTION DESCRIPTION -->
        <div class="input-group mb-3">
          <label class="w-100" for="description">
            <span class="align-middle">{{ $t('message.metadata.description') }}</span>
            <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipDistributionDescription')">info</i>
          </label>
          <textarea class="form-control w-100"
                    id="description"
                    name="Description"
                    type="text"
                    :placeholder="`${$t('message.metadata.enterDescription')}`"
                    :aria-label="$t('message.metadata.enterDescription')"
                    aria-describedby="description"
                    v-model="distribution.description">
          </textarea>
          <br>
        </div>
        <div class="row">
          <div class="col">
            <!-- ADD DISTRIBUTION FORMAT -->
            <div class="input-group mb-3">
              <label class="w-100" for="format">
                <span class="align-middle">{{ $t('message.metadata.format') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipDistributionFormat')">info</i>
              </label>
              <input class="form-control w-100"
                      id="format"
                      name="Format"
                      type="text" 
                      list="formats"
                      :placeholder="$t('message.metadata.chooseFormat')"
                      :aria-label="$t('message.metadata.chooseFormat')"
                      aria-describedby="format"
                      v-model="distribution.format">
              <datalist id="formats">
                <option value="UNKNOWN">{{ $t('message.datasetDetails.upload.unknownFormat') }}</option>
                <option v-for="(format, i) in formatVocabulary" :key="`format${i}`" :value="format.substring(format.lastIndexOf('/') + 1)">{{ format.substring(format.lastIndexOf('/') + 1) }}</option>
              </datalist>
            </div>
          </div>
          <div class="col">
            <!-- ADD DISTRIBUTION LICENCE -->
            <div class="input-group mb-3">
              <label class="w-100" for="licence">
                <span class="align-middle">{{ $t('message.metadata.license') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipDistributionLicence')">info</i>
              </label>
              <input class="form-control w-100"
                    id="licence"
                    name="Licence"
                    type="text"
                    list="licences"
                    :placeholder="`${$t('message.metadata.chooseLicense')}`"
                    :aria-label="$t('message.metadata.chooseLicense')"
                    aria-describedby="licence"
                    v-model="distribution.licence">
              <datalist id="licences">
                <option value="Example Licence Value">Example Licence</option>
              </datalist>
            </div>
          </div>
        </div>
        <!-- ADD DISTRIBUTION DOWNLOAD URL -->
        <div class="input-group mb-3">
          <div class="w-100" v-if="useDownloadUrl">
            <label class="w-100" for="downloadUrl">
            <span class="align-middle">{{ $t('message.metadata.downloadUrl') }}</span>
            <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipDistributionDownloadUrl')">info</i>
          </label>
            <input class="form-control w-100"
                   :class="{ 'is-invalid': errors.first('DownloadUrl') }"
                   id="downloadUrl"
                   name="DownloadUrl"
                   type="text"
                   :placeholder="`${$t('message.metadata.enterDownloadUrl')}`"
                   :aria-label="$t('message.metadata.enterDownloadUrl')"
                   aria-describedby="downloadUrl"
                   v-model="distribution.downloadUrl"
                   v-validate="{ url: { require_protocol: true }}">
            <div class="invalid-feedback" v-if="errors.first('DownloadUrl')">
              {{ errors.first('DownloadUrl') }}
            </div>
            <br>
          </div>
          <br>
          <div class="custom-control custom-checkbox w-100">
            <input id="useDownloadUrl" type="checkbox" class="custom-control-input" @click="useDownloadUrl = !useDownloadUrl">
            <label for="useDownloadUrl" class="custom-control-label">
              {{ $t('message.metadata.useDownloadUrl') }}
            </label>
          </div>
        </div>
        <!-- ADD DISTRIBUTION BUTTON -->
        <button id="addDistributionButton" class="btn btn-primary mt-2" @click='addDistributions()'>
          {{ $t('message.metadata.addDistribution')}}
        </button>
      </div>
    </div>

    <hr class="mt-5">

    <!-- LIST OF ADDED DISTRIBUTIONS -->
    <div class="row mb-3">
      <div class="col-12">
        <div class="row mb-5">
          <div class="col-10 offset-1 py-2 text-left">
            <h3>{{ $t('message.metadata.distributions') }} ({{ distributions.length }})</h3>
          </div>
          <div class="col-12" v-if="distributions.length === 0">
            <div class="p-0 py-3 text-center text-sm-left alert alert-secondary alert-dismissible fade show" role="alert">
              <div class="row">
                <div class="col-1 m-auto text-center">
                  <i class="material-icons">info</i>
                </div>
                <div class="col-10">
                  <p class="mb-0">{{ $t('message.metadata.distributionsEmpty') }}</p>
                </div>
                <div class="col-1">
                  <button class="close pt-0"
                          type="button"
                          data-dismiss="alert"
                          aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
              </div>
            </div>
          </div>
          <div class="col-12" v-for="(distribution, i) in distributions" :key="`distribution${i}`">
            <!-- DISTRIBUTION -->
            <li class="row">
              <span class="d-inline-block col-md-1 col-2 pr-md-1 pr-0 m-md-0 m-auto">
                <div v-if="distribution.format" class="circle float-md-right text-center text-white text-truncate"
                     :type="distribution.format.substring(distribution.format.lastIndexOf('/') + 1)"
                     :title="distribution.format.substring(distribution.format.lastIndexOf('/') + 1)">
                  <span>{{ distribution.format.substring(distribution.format.lastIndexOf('/') + 1) }}</span>
                </div>
              </span>
              <span class="col-10">
                <span class="row">
                  <span class="d-inline-block col-9">
                    <h6 class="m-0">{{ distribution.title }}</h6>
                    <span class="mt-2 d-block text-muted text-truncate">
                      <small>
                        {{ distribution.description }}
                      </small>
                    </span>
                    <small class="mt-2 d-block">
                      <span class="font-weight-bold">
                        {{ $t('message.metadata.license') }} : {{ distribution.licence }}
                      </span>
                    </small>
                  </span>
                  <span class="d-inline-block col-3">
                    <button class="btn btn-primary" data-toggle="modal" @click="editDistributionModal(distribution)" data-target="#updateModal">{{ $t('message.datasetDetails.edit') }}</button>
                    <button class="btn btn-danger" data-toggle="modal" @click="deleteDistributionModal(distribution)" data-target="#deleteModal">{{ $t('message.datasetDetails.delete') }}</button>
                  </span>
                </span>
              </span>
            </li>
            <hr>
          </div>
        </div>
      </div>
    </div>

    <!-- UPDATE DISTRIBUTION MODAL -->
    <div v-if="updatingDistribution" class="modal fade" id="updateModal" tabindex="-1" role="dialog" aria-labelledby="updateModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="updateModalLabel">{{distributionEdit.title}}</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="col-10 offset-1">
              <!-- UPDATE DISTRIBUTION TITLE -->
              <div class="input-group mb-2">
                <input class="form-control w-100"
                       name="UpdateTitle"
                       type="text"
                       :placeholder="$t('message.metadata.title')"
                       :aria-label="$t('message.metadata.title')"
                       aria-describedby="title"
                       v-model="distributionEdit.title"
                       v-validate="'required'">
                <br>
                <div class="alert alert-danger w-100" role="alert" v-if="errors.first('UpdateTitle')">
                  {{ errors.first('UpdateTitle') }}
                </div>
              </div>
              <!-- UPDATE DISTRIBUTION DESCRIPTION -->
              <div class="input-group mb-2">
                <textarea class="form-control w-100"
                          name="UpdateDescription"
                          type="text"
                          :placeholder="$t('message.metadata.description')"
                          :aria-label="$t('message.metadata.description')"
                          aria-describedby="description"
                          v-model="distributionEdit.description">
                </textarea>
              </div>
              <!-- UPDATE DISTRIBUTION FORMAT -->
              <div class="input-group mb-2">
                <input class="form-control w-100"
                       name="UpdateFormat"
                       type="text"
                       :placeholder="$t('message.metadata.format')"
                       :aria-label="$t('message.metadata.format')"
                       aria-describedby="format"
                       v-model="distributionEdit.format">
              </div>
              <!-- UPDATE DISTRIBUTION LICENCE -->
              <div class="input-group mb-2">
                <input class="form-control w-100"
                       name="UpdateLicence"
                       type="text"
                       :placeholder="$t('message.metadata.license')"
                       :aria-label="$t('message.metadata.license')"
                       aria-describedby="licence"
                       v-model="distributionEdit.licence">
              </div>
              <!-- UPDATE DISTRIBUTION DOWNLOAD URL -->
              <div class="input-group mb-2">
                <input class="form-control w-100"
                       name="UpdateDownloadUrl"
                       type="text"
                       :placeholder="$t('message.metadata.downloadUrl')"
                       :aria-label="$t('message.metadata.downloadUrl')"
                       aria-describedby="downloadUrl"
                       v-model="distributionEdit.downloadUrl"
                       v-validate="{ url: { require_protocol: true }}">
                <div class="invalid-feedback" v-if="errors.first('UpdateDownloadUrl')">
                  {{ errors.first('UpdateDownloadUrl') }}
                </div>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">{{ $t('message.metadata.cancel') }}</button>
            <button type="button" data-dismiss="modal" class="btn btn-primary" @click="editDistribution(distributionEdit)">{{ $t('message.metadata.update') }}</button>
          </div>
        </div>
      </div>
    </div>

    <!-- DELETE DISTRIBUTION MODAL -->
    <div v-if="deletingDistribution" class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="deleteModalLabel">{{ $t('message.metadata.deleteItem') }}</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-footer">
            <button type="button" @click="cancelDelete()" class="btn btn-secondary" data-dismiss="modal">{{ $t('message.metadata.no') }}</button>
            <button type="button" @click="deleteDistribution()" data-dismiss="modal" class="btn btn-primary">{{ $t('message.metadata.yes') }}</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  /* eslint-disable quotes */
  import $ from 'jquery';
  import { mapActions, mapGetters } from 'vuex';
  import { normalize, getTranslationFor } from '../../utils/helpers';
  import fileTypes from '../../../static/MDR_fileTypes.json';

  export default {
    name: 'Distribution',
    dependencies: ['uploadService'],
    components: {},
    data() {
      return {
        editingDataset: false,
        distributionVisible: true,
        useDownloadUrl: false,
        updatingDistribution: false,
        deletingDistribution: null,
        distributions: [],
        distribution: {
          title: '',
          description: '',
          format: '',
          licence: '',
          downloadUrl: '',
        },
        distributionEdit: {
          oldTitle: '',
          title: '',
          description: '',
          format: '',
          licence: '',
        },
      };
    },
    props: {},
    computed: {
      ...mapGetters('auth', [
        'securityAuth',
        'getRTPToken',
      ]),
      ...mapGetters('upload', [
        'getValidate',
        'getError',
        'getID',
        'getTitle',
        'getDescription',
        'getKeywords',
        'getCategory',
        'getContactInfo',
        'getPublisherInfo',
        'getCatalogue',
        'getAPIUploadData',
      ]),
      query() {
        if (typeof this.$route.query.catalog === 'string') return { catalog: this.$route.query.catalog, locale: this.$route.query.locale };
        return { locale: this.$route.query.locale };
      },
      formatVocabulary() {
        return fileTypes['@graph'].map(fileType => fileType['@id']);
      },
      useOnlyDownloadUrl() {
        let onlyDownloadUrlsUsed = true;
        this.distributions.forEach((dist) => {
          // Return false if there exists a distribution without downloadUrl
          if (!dist.downloadUrl) onlyDownloadUrlsUsed = false;
        });
        // Return true if all downloadUrls are set
        return onlyDownloadUrlsUsed;
      },
    },
    methods: {
      ...mapActions('upload', [
        'setStep',
        'setValidate',
        'setError',
        'setLoading',
        'setID',
        'addDistribution',
        'setDistributions',
        'addApiUploadData',
      ]),
      normalize,
      getTranslationFor,
      editDistributionModal(distribution) {
        this.updatingDistribution = true;
        this.distributionEdit.oldTitle = distribution.title;
        this.distributionEdit.title = distribution.title;
        this.distributionEdit.description = distribution.description;
        this.distributionEdit.format = distribution.format;
        this.distributionEdit.licence = distribution.licence;
        this.distributionEdit.downloadUrl = distribution.downloadUrl;
      },
      deleteDistributionModal(distribution) {
        this.deletingDistribution = distribution;
      },
      editDistribution(distribution) {
        /* eslint-disable no-param-reassign */
        this.distributions.forEach((element) => {
          if (element.title === distribution.oldTitle) {
            element.title = distribution.title;
            element.description = distribution.description;
            element.format = distribution.format;
            element.licence = distribution.licence;
            element.downloadUrl = distribution.downloadUrl;
          }
        });
      },
      cancelDelete() {
        this.deletingDistribution = null;
      },
      deleteDistribution() {
        if (this.deletingDistribution) {
          const index = this.distributions.findIndex(dist => dist.title === this.deletingDistribution.title);
          if (!Number.isNaN(index)) {
            this.distributions.splice(index, 1);
            this.setDistributions(this.distributions);
          }
          this.cancelDelete();
        }
      },
      toggleDistribution() {
        this.distributionVisible = !this.distributionVisible;
        if (this.distributionVisible) {
          this.$nextTick(() => {
            // Activate Bootstrap Tooltips
            $('[data-toggle="tooltip"]').tooltip({
              container: 'body',
            });
          });
        }
      },
      formatDate(date) {
        const timezoneOffset = date.getTimezoneOffset();
        const timezoneDifference = timezoneOffset <= 0 ? '+' : '-';
        const UTCDate = `${date.toISOString().replace('Z', '')}${timezoneDifference}${this.makeTwoDigit(timezoneOffset / 60)}:${this.makeTwoDigit(timezoneOffset % 60)}`;
        return UTCDate;
      },
      makeTwoDigit(number) {
        const norm = Math.floor(Math.abs(number));
        return (norm < 10 ? '0' : '') + norm;
      },
      themeMapping(categories) {
        const theme = [];
        categories.forEach((category) => {
          if (category === 'Environment') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/ENVI' });
          }
          if (category === 'Agriculture, fisheries, forestry and food') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/AGRI' });
          }
          if (category === 'Economy and finance') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/ECON' });
          }
          if (category === 'Education, culture and sport') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/EDUC' });
          }
          if (category === 'Energy') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/ENER' });
          }
          if (category === 'Government and public sector') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/GOVE' });
          }
          if (category === 'Health') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/HEAL' });
          }
          if (category === 'International issues') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/INTR' });
          }
          if (category === 'Justice, legal system and public safety') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/JUST' });
          }
          if (category === 'Provisional data') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/OP_DATPRO' });
          }
          if (category === 'Regions and cities') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/REGI' });
          }
          if (category === 'Population and society') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/SOCI' });
          }
          if (category === 'Science and technology') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/TECH' });
          }
          if (category === 'Transport') {
            theme.push({ '@id': 'http://publications.europa.eu/resource/authority/data-theme/TRAN' });
          }
        });
        return theme;
      },
      addDistributions() {
        this.$Progress.start();
        this.$validator.validate().then((valid) => {
          if (valid) {
            // Add Distribution
            const distribution = {
              title: this.distribution.title,
              description: this.distribution.description,
              format: this.distribution.format,
              licence: this.distribution.licence,
              downloadUrl: this.distribution.downloadUrl,
            };
            this.distributions.push(distribution);
            console.log('ADD DIST');
            this.addDistribution(distribution);
            // Empty fields for the next input
            this.distribution.title = '';
            this.distribution.description = '';
            this.distribution.format = '';
            this.distribution.licence = '';
            this.distribution.downloadUrl = '';
            this.$validator.reset();
            this.$Progress.finish();
          } else {
            this.$Progress.fail();
          }
        });
      },
      reverseString(str) {
        return str.split("").reverse().join("");
      },
      isNotModified() {
        // Check if title/ID, description, catalog, publisher, contact points, distribution (title, description, format, licence, downloadUrl) have been modified
        // return true if dataset is not modified
        return false;
      },
      tryUpload(datasetTitle, rdf, rtpAccessToken) {
        this.uploadService.upload(datasetTitle, this.getCatalogue, rdf, rtpAccessToken, !this.useOnlyDownloadUrl).then((result) => {
          // Prepare APIUploadData for FileUpload
          result.data.distributions.forEach((distribution) => {
            // Add formats
            distribution.format = (this.distributions.find(dist => dist.title === distribution.title)).format;
            // Add file slots
            distribution.file = {
              fileName: '',
              uploadSuccess: false,
              uploadProcessing: false,
            };
          });
          this.addApiUploadData(result.data);
          localStorage.setItem('apiUploadData', JSON.stringify(result.data));
          this.$Progress.finish();
          this.setLoading(false);
          if (this.useOnlyDownloadUrl) {
            this.setStep(4);
            this.$router.push({ name: 'UploadPageReview', query: this.query, params: this.$route.params });
          } else {
            this.setStep(3);
            this.$router.push({ name: 'UploadPageFileUpload', query: this.query, params: this.$route.params });
          }
        }).catch((err) => {
          this.catchError(err);
        });
      },
      catchError(err) {
        this.setError(`ERROR: ${err.response.status} (${err.response.statusText})`);
        this.$Progress.fail();
        this.setLoading(false);
      },
      // Read Data from window.localStorage
      loadDataFromLocalStorage() {
        // Read distribution attributes from local storage
        if (localStorage.getItem('apiUploadData')) {
          this.addApiUploadData(JSON.parse(localStorage.getItem('apiUploadData')));
        }
        if (localStorage.getItem('distributions')) {
          this.distributions = JSON.parse(localStorage.getItem('distributions'));
          this.setDistributions(this.distributions);
        }
        if (localStorage.getItem('distribution')) {
          this.distribution = JSON.parse(localStorage.getItem('distribution'));
        }
      },
      // Read Data from $route.params when EDITING
      loadDataFromParams() {
        // Set editingDataset
        this.editingDataset = this.$route.params.id !== undefined && this.$route.params.distributions !== undefined;

        if (this.$route.params.distributions && this.$route.params.distributions.length > 0) {
          this.$route.params.distributions.forEach((elements) => {
            const distribution = {
              title: getTranslationFor(elements.title, this.$route.query.locale, []),
              description: getTranslationFor(elements.description, this.$route.query.locale, []),
              format: getTranslationFor(elements.format, this.$route.query.locale, []),
              licence: getTranslationFor(elements.licence, this.$route.query.locale, []),
              downloadUrl: elements.downloadUrl ? elements.downloadUrl : '',
            };
            this.distributions.push(distribution);
          });
          this.setDistributions(this.distributions);
        }
      },
      next() {
        // Avoid uploading the same distributions twice when editing or switching between the steps ...
        // Just skip the validation and jump to Step 3 / 4 if distributions have been uploaded already and are not modified!
        if (this.isNotModified()) {
          if (this.useOnlyDownloadUrl) {
            this.setStep(4);
            this.$router.push({ name: 'UploadPageReview', query: this.query, params: this.$route.params });
          } else {
            this.setStep(3);
            this.$router.push({ name: 'UploadPageFileUpload', query: this.query, params: this.$route.params });
          }
          return;
        }

        /* eslint-disable */
        this.$Progress.start();
        this.setLoading(true);

        const rdf =  {
          "@context": {
            "dc": "http://purl.org/dc/elements/1.1/",
            "dcat": "http://www.w3.org/ns/dcat#",
            "dct": "http://purl.org/dc/terms/",
            "dcterms": "http://purl.org/dc/terms/",
            "edp": "https://europeandataportal.eu/voc#",
            "foaf": "http://xmlns.com/foaf/0.1/",
            "locn": "http://www.w3.org/ns/locn#",
            "owl": "http://www.w3.org/2002/07/owl#",
            "rdf": "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
            "rdfs": "http://www.w3.org/2000/01/rdf-schema#",
            "schema": "http://schema.org/",
            "skos": "http://www.w3.org/2004/02/skos/core#",
            "time": "http://www.w3.org/2006/time",
            "vcard": "http://www.w3.org/2006/vcard/ns#",
            "xsd": "http://www.w3.org/2001/XMLSchema#"
          },
          "@graph": [
            {
              "@id": "https://test.de/dataset111",
              "@type": "dcat:Dataset",
              "dcat:distribution": [
              ],
              "dcterms:description": this.getDescription,
              "dcterms:issued": {
                "@type": "xsd:dateTime",
                "@value": this.formatDate(new Date()),
              },
              "dcterms:language": {
                "@id": "http://publications.europa.eu/resource/authority/language/ENG"
              },
              "dcterms:modified": {
                "@type": "xsd:dateTime",
                "@value": this.formatDate(new Date())
              },
              "dcterms:title": this.getTitle
            }
          ]
        };
        const token = this.$keycloak.token;

        // Check if distribution exists
        if (Array.isArray(this.distributions) && this.distributions.length > 0) {

          let tempresourceCount = 1;
            this.distributions.forEach(distribution => {
              let dist = {
                        "@id": "https://test.de/dataset111/resource/"+tempresourceCount,
                        "@type": "dcat:Distribution",
                        "dcterms:license": distribution.licence,
                        "dcterms:description": distribution.description,
                        "dcterms:format": { "@id": distribution.format },
                        "dcterms:title": distribution.title,
                        "dcat:accessURL": { "@id": distribution.downloadUrl },
                      };
                let id = {
                        "@id": "https://test.de/dataset111/resource/"+tempresourceCount
                      };
              rdf["@graph"].push(dist);
              rdf["@graph"][0]["dcat:distribution"].push(id);
              tempresourceCount++;
          });

          // Adding keywords in RDF
          if (Array.isArray(this.getKeywords) && this.getKeywords.length > 0 && this.getKeywords[0] != "") {
            rdf["@graph"][0]["dcat:keyword"] = this.getKeywords;
          }

          // Adding contact point in RDF
          if (this.getContactInfo.type != '' && this.getContactInfo.name != '' && this.getContactInfo.email != '') {
            const contactPoint = {
              "@type" : `vcard:${this.getContactInfo.type}`,
              "vcard:fn": this.getContactInfo.name,
              "vcard:hasEmail": {
                "@id": `mailto:${this.getContactInfo.email}`
              }
            };
            rdf["@graph"][0]["dcat:contactPoint"] = contactPoint;
          }

          // Adding publisher in RDF
          if (this.getPublisherInfo.name != '' && this.getPublisherInfo.type != '' && this.getPublisherInfo.homepage != '') {
            const publisherInfo = {
              "@type": `http://xmlns.com/foaf/0.1/${this.getPublisherInfo.type}`,
              "foaf:homepage":
              {
                "@id": this.getPublisherInfo.homepage,
                "@type": "@id"
              },
              "foaf:name": this.getPublisherInfo.name
            };
            rdf["@graph"][0]["dct:publisher"] = publisherInfo;
          }

          // Adding categories in RDF
          if (Array.isArray(this.getCategory) && this.getCategory.length > 0) {
            rdf["@graph"][0]["dcat:theme"] = this.themeMapping(this.getCategory);
          }

          // Normalizing dataset ID (as per torben jastrow 17/07/2019)
          let datasetTitle = (this.getTitle.toLowerCase()).replace(/[^a-zA-Z0-9]/g,'-');
          let datasetId = this.getTitle.replace(/\s+/g, '-').toLowerCase();
          datasetId = this.normalize(datasetId);

          // Store datasetID
          this.setID(datasetId);

          this.$keycloak.getRtpToken().then((rtpToken) => {
            // Check if distributions have been uploaded already 
            // --> If distributions are already uploaded at this point, user is trying to edit an existing dataset or adding more distributions to the current dataset
            // --> Then DELETE and CREATE dataset again
            // --> Else if there aren´t any distributions uploaded yet, we can simply CREATE the dataset
            if (this.editingDataset || this.getAPIUploadData) {
              if (this.editingDataset) datasetId = this.$route.params.id;
              this.uploadService.deleteDistribution(datasetId, this.getCatalogue, rtpToken.data.access_token).then((res) => {
                return res;
              }).then((res) => {
                this.tryUpload(datasetTitle, rdf, rtpToken.data.access_token);
              }).catch((err) => {
                this.catchError(err);
              });
            } else {
              this.tryUpload(datasetTitle, rdf, rtpToken.data.access_token);
            }
          });
        } else {
          this.setError('ERROR: Please add at least one distribution!');
          this.$Progress.fail();
          this.setLoading(false);
        }
      },
    },
    watch: {
      getValidate: {
        handler(validate) {
          if (validate) {
            // Call next function
            this.next();
            // Reset Validate State
            this.setValidate(false);
          }
        },
      },
      // Watch on all distribution attributes to store them into local storage on change
      getID: {
        handler(newID) {
          localStorage.setItem('ID', JSON.stringify(newID));
        },
        deep: true,
      },
      distributions: {
        handler(newDistributions) {
          localStorage.setItem('distributions', JSON.stringify(newDistributions));
        },
        deep: true,
      },
      distribution: {
        handler(newDistribution) {
          localStorage.setItem('distribution', JSON.stringify(newDistribution));
        },
        deep: true,
      },
    },
    created() {
      // Load Data from Route Params when EDITing
      if (!this.editingDataset) this.loadDataFromParams();
      this.$nextTick(() => {
        // Activate Bootstrap Tooltips
        $('[data-toggle="tooltip"]').tooltip({
          container: 'body',
        });
      });
    },
    mounted() {
      // Load Data from Local Storage if not editing
      if (!this.editingDataset) this.loadDataFromLocalStorage();
    },
  };
</script>

<style lang="scss" scoped>
  label {
    font-weight: bold;

    &.custom-control-label {
      font-weight: normal;
    }
  }

  .heading {
    display: inline-block;
  }

  .heading, .description, .arrow {
    cursor: pointer !important;
  }

  .custom-select {
    -webkit-appearance: none !important;
  }

  .custom-control-label:before {
    background-color:white;
  }

  .circle {
    width: 40px;
    height: 40px;
    margin: 0 auto;
    padding: 20px 0;
    font-size: 12px;
    line-height: 1px;
    border-radius: 50%;
    background-color: #000000;
    &[type="HTML"] {
      background-color: #55a1ce;
    }
    &[type="JSON"] {
      background-color: #ef7100;
    }
    &[type="XML"] {
      background-color: #ef7100;
    }
    &[type="TXT"] {
      background-color: #74cbec;
    }
    &[type="CSV"] {
      background-color: #dfb100;
    }
    &[type="XLS"] {
      background-color: #2db55d;
    }
    &[type="ZIP"] {
      background-color: #686868;
    }
    &[type="API"] {
      background-color: #ec96be;
    }
    &[type="PDF"] {
      background-color: #e0051e;
    }
    &[type="RDF"],
    &[type="NQUAD"],
    &[type="NTRIPLES"],
    &[type="TURTLE"] {
      background-color: #0b4498;
    }
  }

  /*** MATERIAL ICONS ***/
  .material-icons.small-icon {
    font-size: 21px;
  }
</style>
